HDU 3271 SNIBB

SNIBB

Time Limit: 1000ms

Memory Limit: 32768KB

This problem will be judged on HDU. Original ID: 3271
64-bit integer IO format: %I64d      Java class name: Main

As we know, some numbers have interesting property. For example, any even number has the property that could be divided by 2. However, this is too simple. 
  One day our small HH finds some more interesting property of some numbers. He names it the “Special Numbers In Base B” (SNIBB). Small HH is very good at math, so he considers the numbers in Base B. In Base B, we could express any decimal numbers. Let’s define an expression which describe a number’s “SNIBB value”.(Note that all the “SNIBB value” is in Base 10)
  
    Here N is a non-negative integer; B is the value of Base.
  For example, the “SNIBB value” of “1023” in Base “2” is exactly:10
(As we know (1111111111)2=(1023)(10))
  Now it is not so difficult to calculate the “SNIBB value” of the given N and B.
But small HH thinks that must be tedious if we just calculate it. So small HH give us some challenge. He would like to tell you B, the “SNIBB value” of N , and he wants you to do two kinds of operation:
1.  What is the number of numbers (whose “SNIBB value” is exactly M) in the range [A,B];
2.  What it the k-th number whose “SNIBB value” is exactly M in the range [A,B]; (note that the first one is 1-th but not 0-th)

Here M is given.

Input

There are no more than 30 cases.
  For each case, there is one integer Q,which indicates the mode of operation;
  If Q=1 then follows four integers X,Y,B,M, indicating the number is between X and Y, the value of base and the “SNIBB value”.
(0<=X,Y<=2000000000,2<=B<=64,0<=M<=300)
  If Q=2 then follows five integers X,Y,B,M,K, the first four integer has the same meaning as above, K indicates small HH want to know the k-th number whose “SNIBB value” is exactly M.
(1<=K<=1000000000)

Output

Output contains two lines for each cases.
  The first line is the case number, the format is exactly “Case x:”, here x stands for the case index (start from 1.).
  Then follows the answer.
  If Q=2 and there is no such number in the range, just output “Could not find the Number!” (without quote!) in a single line.

Sample Input

1 0 10 10 3
2 0 10 10 1 2
1 0 10 2 1

Sample Output

Case 1:
1
Case 2:
10
Case 3:
4

Hint

In case 1, the number in the range [0,10] whose “SNIBB value” is exactly 3 is 3(in Base 10); In case 2, the numbers in the range [0,10] whose “SNIBB value” is exactly 1 are 1 and 10; Of course the 2-th number is 10. In case 3, the number in the range [0,10] whose “SNIBB value” is exactly 1 is 1,10,100,1000(in Base 2);

Source

HDOJ Monthly Contest – 2010.01.02

解题:数位dp + 二分

 1 #include <bits/stdc++.h>
 2 using namespace std;
 3 using LL = long long;
 4 int dp[45][310],bit[45],op,x,y,b,m,k;
 5 int dfs(int len,int sum,bool flag){
 6     if(-1 == len) return sum == m;
 7     if(!flag && dp[len][sum] != -1) return dp[len][sum];
 8     int ret = 0,u = flag?bit[len]:(b - 1);
 9     for(int i = 0; i <= u; ++i)
10         ret += dfs(len - 1,sum + i,flag && i == u);
11     if(!flag) dp[len][sum] = ret;
12     return ret;
13 }
14 int solve(int n){
15     if(n <= 0) return n == m;
16     int len = 0;
17     while(n){
18         bit[len++] = n%b;
19         n /= b;
20     }
21     return dfs(len - 1,0,true);
22 }
23 int main(){
24     int cs = 1;
25     while(~scanf("%d%d%d%d%d",&op,&x,&y,&b,&m)){
26         memset(dp,-1,sizeof dp);
27         if(x > y) swap(x,y);
28         int p = solve(x - 1),q = solve(y);
29         printf("Case %d:\n",cs++);
30         if(op == 1) printf("%d\n",q - p);
31         else{
32             scanf("%d",&k);
33             if(q - p < k){
34                 puts("Could not find the Number!");
35                 continue;
36             }
37             int low = x,high = y,ans;
38             while(low <= high){
39                 int mid = (static_cast<LL>(low) + high)>>1;
40                 if(solve(mid) - p >= k){
41                     ans = mid;
42                     high = mid - 1;
43                 }else low = mid + 1;
44             }
45             printf("%d\n",ans);
46         }
47     }
48     return 0;
49 }

时间: 2024-08-02 15:12:34

HDU 3271 SNIBB的相关文章

[数位dp] hdu 3271 SNIBB

题意:有两种询问: q=1,在[x,y]区间内,转换成b进制数,数位和为m的有多少个. q=2,在[x,y]区间内,转换成b进制数,数位和是m的第k个数是多少(十进制),不存在按题目给出输出. 思路: 和普通数位dp一样,第几个数的话就是二分判断. 然后就是按常理要开4维,就是dp[i][sum][b][m] i位,和为sum,b进制,最后和为m 但是开不下,所以开3维每次初始化. 注意一下: 1.每次都要初始化 2.x不一定小于y 3.是[x,y]不是(x,y] 代码: #include"cs

[数字dp] hdu 3271 SNIBB

意甲冠军:有两个查询: q=1.在[x,y]间隔,兑换b十进制,数字和m多少个月. q=2.在[x,y]间隔,兑换b十进制,数字是m第一k的数目是多少(十进制),没有输出由给定的主题. 思维: 和比特的平均数dp如,第几个数的话就是二分推断. 然后就是按常理要开4维,就是dp[i][sum][b][m] i位,和为sum,b进制,最后和为m 可是开不下,所以开3维每次初始化. 注意一下: 1.每次都要初始化 2.x不一定小于y 3.是[x,y]不是(x,y] 代码: #include"cstdl

(母函数变形)hdu 2082 找单词

找单词 Time Limit: 1000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 4567    Accepted Submission(s): 3271 Problem Description 假设有x1个字母A, x2个字母B,..... x26个字母Z,同时假设字母A的价值为1,字母B的价值为2,..... 字母Z的价值为26.那么,对于给定的字母,可以找

HDU 6203 ping ping ping [LCA,贪心,DFS序,BIT(树状数组)]

题目链接:[http://acm.hdu.edu.cn/showproblem.php?pid=6203] 题意 :给出一棵树,如果(a,b)路径上有坏点,那么(a,b)之间不联通,给出一些不联通的点对,然后判断最少有多少个坏点. 题解 :求每个点对的LCA,然后根据LCA的深度排序.从LCA最深的点对开始,如果a或者b点已经有点被标记了,那么continue,否者标记(a,b)LCA的子树每个顶点加1. #include<Bits/stdc++.h> using namespace std;

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

hdu 1207 汉诺塔II (DP+递推)

汉诺塔II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4529    Accepted Submission(s): 2231 Problem Description 经典的汉诺塔问题经常作为一个递归的经典例题存在.可能有人并不知道汉诺塔问题的典故.汉诺塔来源于印度传说的一个故事,上帝创造世界时作了三根金刚石柱子,在一根柱子上从下往

[hdu 2102]bfs+注意INF

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2102 感觉这个题非常水,结果一直WA,最后发现居然是0x3f3f3f3f不够大导致的--把INF改成INF+INF就过了. #include<bits/stdc++.h> using namespace std; bool vis[2][15][15]; char s[2][15][15]; const int INF=0x3f3f3f3f; const int fx[]={0,0,1,-1};

HDU 3555 Bomb (数位DP)

数位dp,主要用来解决统计满足某类特殊关系或有某些特点的区间内的数的个数,它是按位来进行计数统计的,可以保存子状态,速度较快.数位dp做多了后,套路基本上都差不多,关键把要保存的状态给抽象出来,保存下来. 简介: 顾名思义,所谓的数位DP就是按照数字的个,十,百,千--位数进行的DP.数位DP的题目有着非常明显的性质: 询问[l,r]的区间内,有多少的数字满足某个性质 做法根据前缀和的思想,求出[0,l-1]和[0,r]中满足性质的数的个数,然后相减即可. 算法核心: 关于数位DP,貌似写法还是

HDU 5917 Instability ramsey定理

http://acm.hdu.edu.cn/showproblem.php?pid=5917 即世界上任意6个人中,总有3个人相互认识,或互相皆不认识. 所以子集 >= 6的一定是合法的. 然后总的子集数目是2^n,减去不合法的,暴力枚举即可. 选了1个肯定不合法,2个也是,3个的话C(n, 3)枚举判断,C(n, 4), C(n, 5) #include <bits/stdc++.h> #define IOS ios::sync_with_stdio(false) using name